<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<event category="CREATE" id="0">
  <actions>
    <action id="603" library="1">
      <!--action name: Code-->
      <kind>CODE</kind>
      <allowRelative>false</allowRelative>
      <question>false</question>
      <canApplyTo>true</canApplyTo>
      <actionType>CODE</actionType>
      <functionName/>
      <relative>false</relative>
      <not>false</not>
      <appliesTo>.self</appliesTo>
      <arguments>
        <argument kind="STRING">startGame = false;

global.spelunkyEXE = "YASM.exe";
global.versionStr = "V1.8.2K8";
global.optDebugLog = false;

global.myFont = font_add_sprite(sFont, ord(' '), false, 0);
global.myFontSmall = font_add_sprite(sFontSmall, ord(' '), false, 0);
global.fullscreen = false;
global.graphicsHigh = true;
global.downToRun = false;

if (joystick_exists(1) or joystick_exists(2)) global.gamepadOn = true;
else global.gamepadOn = false;
global.screenScale = 5;
global.musicVol = 15;
global.soundVol = 15;

global.keyUpVal = vk_up;
global.keyDownVal = vk_down;
global.keyLeftVal = vk_left;
global.keyRightVal = vk_right;
global.keyJumpVal = ord('Z');
global.keyAttackVal = ord('X');
global.keyItemVal = ord('C');
global.keyRunVal = vk_shift;
global.keyBombVal = ord('A');
global.keyRopeVal = ord('S');
global.keyPayVal = vk_space;

global.joyJumpVal = 2;
global.joyAttackVal = 1;
global.joyItemVal = 8;
global.joyRunVal = 3;
global.joyBombVal = 5;
global.joyRopeVal = 6;
global.joyFlareVal = 7;
global.joyPayVal = 4;
global.joyStartVal = 10;

// YASM 1.7 default joystick button labels (see gamepadlabels.cfg)
global.joyJumpLabel = "A";
global.joyAttackLabel = "X";
global.joyItemLabel = "LT";
global.joyRunLabel = "RT";
global.joyBombLabel = "B";
global.joyRopeLabel = "Y";
global.joyPayLabel = "RB";
global.joyStartLabel = "START";

file = file_text_open_read("yasm_settings.cfg");
if (!file) file = file_text_open_read("settings.cfg");
if (file) {
  // read "key=value" pairs
  while (not file_text_eof(file)) {
    str = file_text_read_string(file);
    file_text_readln(file);
    name = k8strkey(str);
    value = k8strvalue(str);
         if (name == "fullscreen") { global.fullscreen = (value == "tan" or value == "true"); }
    else if (name == "graphicsHigh") { global.graphicsHigh = (value == "tan" or value == "true"); }
    else if (name == "downToRun") { global.downToRun = (value == "tan" or value == "true"); }
    else if (name == "gamepadOn") { global.gamepadOn = (value == "tan" or value == "true"); }
    else if (name == "screenScale") { global.screenScale = real(value); }
    else if (name == "musicVol") { global.musicVol = real(value); }
    else if (name == "soundVol") { global.soundVol = real(value); }
    else if (name == "debuglog") { global.optDebugLog = (value == "tan" or value == "true"); }
  }
  file_text_close(file);
}

if (global.musicVol &gt; 19) global.musicVol = 19;
else if (global.musicVol &lt; 2) global.musicVol = 2;

if (global.soundVol &gt; 19) global.soundVol = 19;
else if (global.soundVol &lt; 2) global.soundVol = 2;


file = file_text_open_read("yasm_keys.cfg");
if (!file) file = file_text_open_read("keys.cfg");
if (file) {
  // read "key=value" pairs
  while (not file_text_eof(file)) {
    str = file_text_read_string(file);
    file_text_readln(file);
    name = k8strkey(str);
    value = k8strvalue(str);
         if (name == "up") { global.keyUpVal = real(value); }
    else if (name == "down") { global.keyDownVal = real(value); }
    else if (name == "left") { global.keyLeftVal = real(value); }
    else if (name == "right") { global.keyRightVal = real(value); }
    else if (name == "jump") { global.keyJumpVal = real(value); }
    else if (name == "attack") { global.keyAttackVal = real(value); }
    else if (name == "item") { global.keyItemVal = real(value); }
    else if (name == "run") { global.keyRunVal = real(value); }
    else if (name == "bomb") { global.keyBombVal = real(value); }
    else if (name == "rope") { global.keyRopeVal = real(value); }
    else if (name == "pay") { global.keyPayVal = real(value); }
  }
  file_text_close(file);
}


file = file_text_open_read("yasm_gamepad.cfg");
if (!file) file = file_text_open_read("gamepad.cfg");
if (file)
{
    global.joyJumpVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyAttackVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyItemVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyRunVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyBombVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyRopeVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyFlareVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyPayVal = real(file_text_read_string(file));
    file_text_readln(file);
    global.joyStartVal = real(file_text_read_string(file));
    file_text_close(file);
}

file = file_text_open_read("yasm_gamepadlabels.cfg");
if (!file) file = file_text_open_read("gamepadlabels.cfg");
if (file) {
    global.joyJumpLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyAttackLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyItemLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyRunLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyBombLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyRopeLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyPayLabel = string_upper(file_text_read_string(file));
    file_text_readln(file);
    global.joyStartLabel = string_upper(file_text_read_string(file));
    file_text_close(file);
}

scrLoadYASMSettings();
</argument>
      </arguments>
    </action>
  </actions>
</event>
